<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaycheckPayExpList StructType
 * @subpackage Structs
 */
class PaycheckPayExpList extends AbstractStructBase
{
    /**
     * The paycheckPayExp
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaycheckPayExp[]
     */
    public $paycheckPayExp;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PaycheckPayExpList
     * @uses PaycheckPayExpList::setPaycheckPayExp()
     * @uses PaycheckPayExpList::setReplaceAll()
     * @param \StructType\PaycheckPayExp[] $paycheckPayExp
     * @param bool $replaceAll
     */
    public function __construct(array $paycheckPayExp = array(), $replaceAll = true)
    {
        $this
            ->setPaycheckPayExp($paycheckPayExp)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get paycheckPayExp value
     * @return \StructType\PaycheckPayExp[]|null
     */
    public function getPaycheckPayExp()
    {
        return $this->paycheckPayExp;
    }
    /**
     * This method is responsible for validating the values passed to the setPaycheckPayExp method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaycheckPayExp method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaycheckPayExpForArrayConstraintsFromSetPaycheckPayExp(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $paycheckPayExpListPaycheckPayExpItem) {
            // validation for constraint: itemType
            if (!$paycheckPayExpListPaycheckPayExpItem instanceof \StructType\PaycheckPayExp) {
                $invalidValues[] = is_object($paycheckPayExpListPaycheckPayExpItem) ? get_class($paycheckPayExpListPaycheckPayExpItem) : sprintf('%s(%s)', gettype($paycheckPayExpListPaycheckPayExpItem), var_export($paycheckPayExpListPaycheckPayExpItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The paycheckPayExp property can only contain items of type \StructType\PaycheckPayExp, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set paycheckPayExp value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPayExp[] $paycheckPayExp
     * @return \StructType\PaycheckPayExpList
     */
    public function setPaycheckPayExp(array $paycheckPayExp = array())
    {
        // validation for constraint: array
        if ('' !== ($paycheckPayExpArrayErrorMessage = self::validatePaycheckPayExpForArrayConstraintsFromSetPaycheckPayExp($paycheckPayExp))) {
            throw new \InvalidArgumentException($paycheckPayExpArrayErrorMessage, __LINE__);
        }
        $this->paycheckPayExp = $paycheckPayExp;
        return $this;
    }
    /**
     * Add item to paycheckPayExp value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPayExp $item
     * @return \StructType\PaycheckPayExpList
     */
    public function addToPaycheckPayExp(\StructType\PaycheckPayExp $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaycheckPayExp) {
            throw new \InvalidArgumentException(sprintf('The paycheckPayExp property can only contain items of type \StructType\PaycheckPayExp, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->paycheckPayExp[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PaycheckPayExpList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
